package org.capcaval.ermine.ccjfx;


import javafx.application.Platform;
import javafx.scene.Group;
import javafx.scene.Scene;
import javafx.scene.control.Button;
import javafx.stage.Stage;

import org.capcaval.ccoutils.factory.GenericFactory;
import org.capcaval.ermine.ccjfx.impl.CcJfxFrameFactoryImpl;

public class CcJfxFrame {

	static CcJfxFrameFactory factory = new CcJfxFrameFactoryImpl();

	protected Stage stage;
	protected Scene scene;
	protected Group group;

	public CcJfxFrame(){
		this.init("", 0, 0);
	}
	
	public CcJfxFrame(final String label, final int x, final int y) {
		this.init(label, x, y);
	}
	
	public void init(final String label, final int x, final int y) {

		CcJfxFrame.this.stage = new Stage();
		CcJfxFrame.this.stage.setX(x);
		CcJfxFrame.this.stage.setY(y);
		CcJfxFrame.this.stage.setTitle(label);

		CcJfxFrame.this.group = new Group();
		//CcJfxFrame.this.group.getChildren().add(new Button(label));
		
		CcJfxFrame.this.scene = new Scene(CcJfxFrame.this.group);
		CcJfxFrame.this.stage.setScene(CcJfxFrame.this.scene);
	}

	public Stage getStage() {
		return this.stage;
	}

	public Scene getScene() {
		return this.scene;
	}

	public Group getGroup() {
		return this.group;
	}

	public void display() {
		Platform.runLater(new Runnable() {
			@Override
			public void run() {
				CcJfxFrame.this.stage.show();
			}
		});
	}
}
