package org.capcaval.ermine.ccjfx;

import java.awt.GraphicsDevice;
import java.awt.GraphicsDevice.WindowTranslucency;
import java.awt.GraphicsEnvironment;
import java.util.concurrent.CountDownLatch;
import java.util.concurrent.TimeUnit;

import javafx.application.Platform;

public class JfxTools {

	public static boolean isTransparencySupported() {
		boolean transparencySupported = false;
		
		GraphicsEnvironment ge = GraphicsEnvironment.getLocalGraphicsEnvironment();
		GraphicsDevice gd = ge.getDefaultScreenDevice();

		if (gd.isWindowTranslucencySupported(WindowTranslucency.TRANSLUCENT)) {
			transparencySupported = true;
		}
		
		return transparencySupported;
	}
	
	public static void invokeAndWait(final Runnable runnable) {
		final CountDownLatch syncro = new CountDownLatch(1);
		
		Platform.runLater(new Runnable() {
			@Override
			public void run() {
				runnable.run();
				// the syncro can be raised
				syncro.countDown();
			}
		});
		try {
			syncro.await(2, TimeUnit.SECONDS);
		} catch (InterruptedException e) {
			e.printStackTrace();
		}
	}

}
