package org.capcaval.ermine.ccjfx;

import javafx.application.Application;
import javafx.event.EventHandler;
import javafx.scene.Scene;
import javafx.scene.input.MouseEvent;
import javafx.scene.layout.BorderPane;
import javafx.scene.paint.Color;
import javafx.scene.shape.Rectangle;
import javafx.stage.Stage;
import javafx.stage.StageStyle;

public class SimpleWindowApplication extends Application {
    private double xOffset = 0;
    private double yOffset = 0;

    public static void main(String[] args) {
        launch(args);
    }

    @Override
    public void start(final Stage stage) {
    	try{
    	
        stage.initStyle(StageStyle.UNDECORATED);
        BorderPane root = new BorderPane();

        Rectangle rect = new Rectangle(5,5,40,30);
        rect.setFill(Color.rgb(100, 200, 0, .2));
        root.getChildren().add(rect);
        
        rect.setOnMousePressed(new EventHandler<MouseEvent>() {
            @Override
            public void handle(MouseEvent event) {
                xOffset = event.getSceneX();
                yOffset = event.getSceneY();
            }
        });
        
        rect.setOnMouseDragged(new EventHandler<MouseEvent>() {
            @Override
            public void handle(MouseEvent event) {
                stage.setX(event.getScreenX() - xOffset);
                stage.setY(event.getScreenY() - yOffset);
            }
        });

        Scene scene = new Scene(root, 100, 60);
        //scene.setFill(Color.BLUEVIOLET);
        scene.setFill(Color.rgb(255, 0, 0, .2));
        
        if(JfxTools.isTransparencySupported() == true){
        	stage.initStyle(StageStyle.TRANSPARENT);}
        
        stage.setScene(scene);
        stage.show();
    	}catch (Exception e) {
    		e.printStackTrace();
    		System.out.println("****************************************");
    	}
    }
}