package org.capcaval.ermine.ccjfx.impl;

import java.util.concurrent.atomic.AtomicReference;

import org.capcaval.ermine.ccjfx.CcJfxFrame;
import org.capcaval.ermine.ccjfx.CcJfxFrameCallBack;
import org.capcaval.ermine.ccjfx.CcJfxFrameFactory;
import org.capcaval.ermine.ccjfx.JfxApplication;
import org.capcaval.ermine.ccjfx.JfxTools;

public class CcJfxFrameFactoryImpl implements CcJfxFrameFactory {

	
	@Override
	public CcJfxFrame newInstance(String label, int x, int y) {
		return newInstance(label, x, y, null);
	}

	
	@Override
	public CcJfxFrame newInstance(final String label, final int x, final int y, final CcJfxFrameCallBack cb) {
		// start JavaFx if needed
		JfxApplication.start();
		
		
		final AtomicReference<CcJfxFrame> frameRef = new AtomicReference<>();
		
		JfxTools.invokeAndWait(new Runnable() {
			@Override
			public void run() {
				CcJfxFrame frame = new CcJfxFrame(label, x, y);
				// keep the ref
				frameRef.set( new CcJfxFrame(label, x, y));
				// call the callback
				if(cb!=null){
					cb.notifyFrameCreated(frame);}
			}
		});
		
		
		return frameRef.get();
	}

}
