package org.capcaval.ermine.coves;

import java.lang.reflect.Field;
import java.lang.reflect.Method;
import java.util.ArrayList;
import java.util.List;

import javafx.scene.control.Labeled;

import org.capcaval.ccoutils.lang.ReflectionTools;
import org.capcaval.ermine.coves.analysis.CovesAnalysis;
import org.capcaval.ermine.coves.analysis.CovesGadget;
import org.capcaval.ermine.coves.analysis.CovesPanel;

public class CovesTools {

	static public CovesPanel analyseHmiTree( Class<? extends Controller<?>> rootCtrlType) {
		// get the returning view method
		Method method = null;
		try {
			method = rootCtrlType.getMethod("getView");
		} catch (Exception e) {
			e.printStackTrace();
		}

		// get the view type
		Class<?> viewType = method.getReturnType();

		List<CovesGadget> gadgetList = new ArrayList<>();
		
		// allocate an instance of the panel
		Object viewInstance = null;
		try {
			viewInstance = viewType.newInstance();

			// Analyze all members
			for (Field f : viewType.getDeclaredFields()) {
				if (Labeled.class.isAssignableFrom(f.getType())) {
					f.setAccessible(true);
					// get the labeled instance
					Labeled labeled = (Labeled) f.get(viewInstance);
					CovesGadget gadget =new CovesGadget(f.getName(), labeled.getClass(), labeled.getText());
					gadgetList.add(gadget);
				}
			}

		} catch (Exception e) {
			e.printStackTrace();
		}

		CovesPanel analysis = new CovesPanel(
				"root", viewType , gadgetList.toArray(new CovesGadget[0]), null);

		return analysis;
	}
}
