package org.capcaval.ermine.jfx;

import javafx.application.Platform;

import org.capcaval.ccoutils.application.ApplicationTools;
import org.capcaval.ccoutils.common.CommandResult;
import org.capcaval.ccoutils.converter.Converter;

public class JfxApplicationTools {

	public static CommandResult runApplication(Class<?> applicationType, String... args) {
		return runApplication(applicationType, args, (Converter<?,?>[])null);
	}
	
	public static CommandResult runApplication(final Class<?> applicationType, final String[] args, final Converter<?,?>... converterList) {
		// first start JavaFX
		JfxApplication.start();
		
		System.out.println("Start ccOUtils app");
		
		// secondly run user application
		Platform.runLater(new Runnable() {
			@Override
			public void run() {
				System.out.println("Start");
				CommandResult result = ApplicationTools.runApplication(applicationType, args, converterList);
				System.out.println("Finish");
				System.out.println(result.getReturnMessage());
			}
		});
		
		//TODO sync the end of HMI to this main 
		return null;
	}
	
}
