package org.capcaval.ermine.jfx;


import javafx.application.Platform;
import javafx.scene.Group;
import javafx.scene.Scene;
import javafx.scene.control.Button;
import javafx.stage.Stage;

import org.capcaval.ccoutils.factory.GenericFactory;
import org.capcaval.ermine.jfx.impl.CcJfxFrameFactoryImpl;

public class JfxFrame {

	public static JfxFrameFactory factory = new CcJfxFrameFactoryImpl();

	protected Stage stage;
	protected Scene scene;
	protected Group group;

	public JfxFrame(){
		this.init("", 0, 0);
	}
	
	public JfxFrame(final String label, final int x, final int y) {
		this.init(label, x, y);
	}
	
	public void init(final String label, final int x, final int y) {

		JfxFrame.this.stage = new Stage();
		JfxFrame.this.stage.setX(x);
		JfxFrame.this.stage.setY(y);
		JfxFrame.this.stage.setTitle(label);

		JfxFrame.this.group = new Group();
		//CcJfxFrame.this.group.getChildren().add(new Button(label));
		
		JfxFrame.this.scene = new Scene(JfxFrame.this.group);
		JfxFrame.this.stage.setScene(JfxFrame.this.scene);
	}

	public Stage getStage() {
		return this.stage;
	}

	public Scene getScene() {
		return this.scene;
	}

	public Group getGroup() {
		return this.group;
	}

	public void display() {
		Platform.runLater(new Runnable() {
			@Override
			public void run() {
				JfxFrame.this.stage.show();
			}
		});
	}
}
