package org.capcaval.ermine.jfx;

import java.awt.GraphicsDevice;
import java.awt.GraphicsDevice.WindowTranslucency;
import java.awt.GraphicsEnvironment;
import java.util.concurrent.CountDownLatch;
import java.util.concurrent.TimeUnit;

import javafx.application.Platform;

public class JfxTools {

	public static boolean isTransparencySupported() {
		boolean transparencySupported = false;

		GraphicsEnvironment ge = GraphicsEnvironment
				.getLocalGraphicsEnvironment();
		GraphicsDevice gd = ge.getDefaultScreenDevice();

		if (gd.isWindowTranslucencySupported(WindowTranslucency.TRANSLUCENT)) {
			transparencySupported = true;
		}

		return transparencySupported;
	}

	public static void invokeAndWait(final Runnable runnable) {

		if (Platform.isFxApplicationThread() == true) {
			// just run
			runnable.run();
		} else {
			final CountDownLatch syncro = new CountDownLatch(1);
			
			Platform.runLater(new Runnable() {
				@Override
				public void run() {
					System.out.println(">JFX call");
					runnable.run();
					// the syncro can be raised
					syncro.countDown();
					System.out.println(">JFX call finished");
				}
			});
			try {
				System.out.println(">Wait JFX call   "
						+ Thread.currentThread().getName());
				// syncro.await(2, TimeUnit.SECONDS);
				syncro.await();
				System.out.println(">Wait JFX call finished");
			} catch (InterruptedException e) {
				e.printStackTrace();
			}
		}
	}

}
