package org.capcaval.ermine.jfx.impl;

import java.util.concurrent.atomic.AtomicReference;

import org.capcaval.ermine.jfx.JfxApplication;
import org.capcaval.ermine.jfx.JfxFrame;
import org.capcaval.ermine.jfx.JfxFrameCallBack;
import org.capcaval.ermine.jfx.JfxFrameFactory;
import org.capcaval.ermine.jfx.JfxTools;

public class CcJfxFrameFactoryImpl implements JfxFrameFactory {

	
	@Override
	public JfxFrame newInstance(String label, int x, int y) {
		return newInstance(label, x, y, null);
	}

	
	@Override
	public JfxFrame newInstance(final String label, final int x, final int y, final JfxFrameCallBack cb) {
		// start JavaFx if needed
		JfxApplication.start();
		
		
		final AtomicReference<JfxFrame> frameRef = new AtomicReference<>();
		
		JfxTools.invokeAndWait(new Runnable() {
			@Override
			public void run() {
				JfxFrame frame = new JfxFrame(label, x, y);
				// keep the ref
				frameRef.set( new JfxFrame(label, x, y));
				// call the callback
				if(cb!=null){
					cb.notifyFrameCreated(frame);}
			}
		});
		
		
		return frameRef.get();
	}

}
